<?php
declare(strict_types=1);

namespace Inti\Test\Constraint\Filesystem;

use PHPUnit\Framework\Assert;
use PHPUnit\Framework\Constraint\Constraint;

use function fileperms;
use function sprintf;

/**
 * Class HasPermissions
 *
 * @package Inti\Test\Constraint\Filesystem
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-test
 */
final class HasPermissions extends Constraint
{
    private int $value;

    public function __construct(int $value)
    {
        $this->value = $value;
    }

    protected function matches($other): bool
    {
        Assert::assertFileExists($other);

        return $this->value === (fileperms($other) & 0777);
    }

    public function toString(): string
    {
        return sprintf('has permissions `%o`', $this->value);
    }
}
